function RaycastWeaponBase:toggle_hybrid_mode()
    local factory_id = self._factory_id
    local blueprint = self._blueprint
    local has_hybrid_mode_perk = managers.weapon_factory:has_perk("hybrid_mode", factory_id, blueprint)
    if has_hybrid_mode_perk then
        self.has_hybrid_mode_enabled = not self.has_hybrid_mode_enabled
        self:update_hybrid_falloff()
        HudChallengeNotification.queue("", self.has_hybrid_mode_enabled and "SMG Mode" or "AR Mode")
        self._zoom = self.has_hybrid_mode_enabled and 63 or 45
        -- log("self._zoom"..self._zoom)
    end
    return has_hybrid_mode_perk
end

local HYBRID_KIT_RaycastWeaponBase_update_next_shooting_time = RaycastWeaponBase.update_next_shooting_time 
function RaycastWeaponBase:update_next_shooting_time()
    if self.has_hybrid_mode_enabled then
        local next_fire = self._hybrid_mode_rof / self:fire_rate_multiplier()
        self._next_fire_allowed = self._next_fire_allowed + next_fire
    else
        HYBRID_KIT_RaycastWeaponBase_update_next_shooting_time(self)
    end
end

function RaycastWeaponBase:update_hybrid_falloff()
    -- log("update_hybrid_falloff")
    -- for k,v in pairs(self._parts) do
    --     if k == "wpn_fps_m4_uupg_b_hybrid" then
    --         log(tostring(v.unit:position()))
    --     end
    -- end
    
    if not self._backup_falloff then
        self:backup_falloff()
    end

    -- Get the fallooff of the the weapon specified in the xml
    local weapon_tweak = tweak_data.weapon[self._hybrid_mode_falloff_based_on]
	local falloff_data = weapon_tweak.damage_falloff or {
		optimal_range = weapon_tweak.damage_near,
		far_falloff = weapon_tweak.damage_far
	}

	self._optimal_distance = self.has_hybrid_mode_enabled and falloff_data.optimal_distance or self._backup_falloff._optimal_distance or 0
	self._optimal_range = self.has_hybrid_mode_enabled and falloff_data.optimal_range or self._backup_falloff._optimal_range or 0
	self._near_falloff = self.has_hybrid_mode_enabled and falloff_data.near_falloff or self._backup_falloff._near_falloff or 0
	self._far_falloff = self.has_hybrid_mode_enabled and falloff_data.far_falloff or self._backup_falloff._far_falloff or 0
	self._near_mul = self.has_hybrid_mode_enabled and falloff_data.near_multiplier or self._backup_falloff._near_mul or 0
	self._far_mul = self.has_hybrid_mode_enabled and falloff_data.far_multiplier or self._backup_falloff._far_mul or 0
end

function RaycastWeaponBase:backup_falloff()
    self._backup_falloff = {}
    self._backup_falloff._optimal_distance = self._optimal_distance
    self._backup_falloff._optimal_range = self._optimal_range
    self._backup_falloff._near_falloff = self._near_falloff
    self._backup_falloff._far_falloff = self._far_falloff
    self._backup_falloff._near_mul = self._near_mul
    self._backup_falloff._far_mul = self._far_mul
end